/* $Id: argset_ctn.h,v 1.2 2003/06/03 12:10:59 mquinson Exp $ */

/* argset_ctn.h - defines one argument of tests.                             */

/* Copyright (C) 2001,2002,2003 the OURAGAN project.                         */
/* Code GPL'ed (see www.gnu.org).                                            */
/* Author(s): Martin Quinson                                                 */

#ifndef _FAST_ARGSET_CTN_H
#define _FAST_ARGSET_CTN_H

#include "argset.h" /* to get the def of types. FIXME: is it circular ? */

/*====[ definitions of the several kind of content ]=========================*/
/*----[ generic type ]-------------------------------------------------------*/
struct fast_argset_ctn_ { 
  fast_argset_type_t type;
};
typedef struct fast_argset_ctn_ fast_argset_ctn_t;
/*----[ num type ]-----------------------------------------------------------*/
struct fast_argset_ctn_num_ { 
  fast_argset_type_t type; /* this arg is numerical */

  double val; /* current value */

  int slot_count;
  int slot_cur;
  double *min;
  double *incr;
  double *max;
};
typedef struct fast_argset_ctn_num_ fast_argset_ctn_num_t;

/*----[ set of strings type ]------------------------------------------------*/
struct fast_argset_ctn_string_ {
  fast_argset_type_t type; /* this arg is a string */

  int pos; /* current value number */
  int size;
  char **values;
};
typedef struct fast_argset_ctn_string_ fast_argset_ctn_string_t;

/*====[ prototype of functions ]=============================================*/
/*----[ mem management, initialisation ]-------------------------------------*/
/* parse the string and allocate a new struct */
int fast_argset_ctn_from_string(fast_argset_type_t type,
				char *string,
				/*OUT*/fast_argset_ctn_t **where);
/* parse the string and add it to the existing struct */
int fast_argset_ctn_add_string(fast_argset_type_t type,char *p,
			       /*OUT*/fast_argset_ctn_t **where);

/* Frees #arg# */
void fast_argset_ctn_free(fast_argset_ctn_t *arg);

/*----[ to see all args ]----------------------------------------------------*/
/* put the value to zero */
int fast_argset_ctn_reset(fast_argset_ctn_t *arg);

/* increments the value if possible (return 1) set to 0 if not (return 0) */
int fast_argset_ctn_inc(fast_argset_ctn_t *arg);

#endif /* _FAST_ARGSET_CTN_H */
