#include "argset_elm.h"

/*----[ fast_argset_elm_free ]-----------------------------------------------*/
/* well, frees the struct                                                    */
/*---------------------------------------------------------------------------*/
void fast_argset_elm_free(fast_argset_elm_t *arg)
{
  if (arg) {
    if (arg->copyof == -1) 
      fast_argset_ctn_free(arg->ctn);
    free(arg);
  }
}
 

/*----[ fast_argset_elm_reset ]----------------------------------------------*/
/* put the value to zero                                                     */
/*---------------------------------------------------------------------------*/
int fast_argset_elm_reset(fast_argset_elm_t *arg) 
{
  if (arg->copyof == -1)
    return fast_argset_ctn_reset(arg->ctn);
  return 1;
}


/*----[ fast_argset_elm_inc ]------------------------------------------------*/
/* Try to increment the value of this element, and return if all went well   */
/*  (overflow being an error)                                                */
/*---------------------------------------------------------------------------*/
int fast_argset_elm_inc(fast_argset_elm_t *arg) 
{
  if (arg->copyof == -1)
    return fast_argset_ctn_inc(arg->ctn);
  return 1;
}
