#ifndef FAST_ARGSET_ELM_H
#define FAST_ARGSET_ELM_H

#include "argset_ctn.h"
#include <stdlib.h>

/*====[ type to build linked list of args ]==================================*/
typedef struct fast_argset_elm_ fast_argset_elm_t;
struct fast_argset_elm_ {
  int to_id; /* true if it should be used while building identificator 
		it's used to ignore some args passed to the bench programm
		(as the function name) in the IDs of the output */

  int copyof; /* number of the elem copied there (-1 if not a copy) */

  fast_argset_ctn_t *ctn;
};

/*====[ prototype of functions ]=============================================*/
/* Frees #arg# */
void fast_argset_elm_free(fast_argset_elm_t *arg);

/* put the value to zero */
int fast_argset_elm_reset(fast_argset_elm_t *arg);

/*----[ fast_argset_elm_inc ]------------------------------------------------*/
/* search the next values of the set of args.                                */
/* Returns if there is an overflow (if there is a carry to handle).          */
/*                                                                           */
/* For example, if there is 3 args in the list after arg,                    */
/*     all integers from 0 to 5, with increment = 1:                         */
/*  list=(0,0,0) -> (1,0,0) false                                            */
/*  list=(4,0,0) -> (0,1,0) false                                            */
/*  list=(4,4,4) -> (0,0,0) true                                             */
/*  list=(4,1,1) -> (0,1,1) true                                             */
/*---------------------------------------------------------------------------*/
int fast_argset_elm_inc(fast_argset_elm_t *begin);

#endif /* FAST_ARGSET_ELM_H */
