/* a stupid bench programm: runs several BLAS functions according to args */
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>

#include "../bench_utils.h"

/* prototypes */
int do_plus(int argc,char **argv);
int do_mult(int argc,char **argv);
void usage(int errcode,char *msg);

#define MAX(a,b) (a > b ? a : b)

/*----[ plus ]---------------------------------------------------------------*/
int do_plus(int argc,char **argv) {
  double *A,*B,*C;
  int M,N;
  int i,j;

  if (argc!=3) {
    fprintf(stderr,"Usage for plus: M N\n");
    exit(1);
  }
  M=atol(argv[1]);
  N=atol(argv[2]);

  printf("plus M=%d;N=%d\n",M,N);
  A=(double *)malloc(sizeof(double)*M*N);
  memset(A,2,sizeof(double)*M*N);
  
  B=(double *)malloc(sizeof(double)*M*N);
  memset(B,2,sizeof(double)*M*N);

  C=(double *)malloc(sizeof(double)*M*N);


  if (!A || !B || !C) {
    fprintf(stderr,"%s:%d: Malloc error, go to hell !\n",
	    __FILE__,__LINE__);
    /* I want it to segfault to not disturbe the bencher */
    A=NULL;
    A[0]=1;
  }
  for (i=0;i<M;i++)
    for (j=0;j<N;j++)
      C[M*j+i]+=A[M*j+i]+B[M*j+i];

  return 0;
}

/*----[ mult ]---------------------------------------------------------------*/
int do_mult(int argc,char **argv) {
  double *A,*B,*C;
  int M,N,K;
  int i,j,k;

  if (argc!=4) {
    fprintf(stderr,"Usage for mult: M N K\n");
    exit(1);
  }
  M=atol(argv[1]);
  N=atol(argv[2]);
  K=atol(argv[3]);

  printf("mult M=%d;N=%d;K=%d\n",M,N,K);
  A=(double *)malloc(sizeof(double)*M*N);
  memset(A,2,sizeof(double)*M*N);
  
  B=(double *)malloc(sizeof(double)*N*K);
  memset(B,2,sizeof(double)*N*K);

  C=(double *)malloc(sizeof(double)*M*K);
  memset(C,0,sizeof(double)*M*K);
  
  if (!A || !B || !C) {
    fprintf(stderr,"%s:%d: Malloc error, go to hell !\n",
	    __FILE__,__LINE__);
    /* I want it to segfault to not disturbe the bencher */
    A=NULL;
    A[0]=1;
  }
  for (i=0;i<M;i++)
    for (j=0;j<N;j++)
      for (k=0;k<K;k++)
	C[M*k+i]+=A[M*j+i]*B[N*k+j];

  return 0;
}

/*----[ usage ]-------------------------------------------------------------*/
void usage(int errcode,char *msg) {
}


/*----[ main ]--------------------------------------------------------------*/
int main(int argc,char **argv)
{
  if (argc==1) {
    fprintf(stderr,"Missing args on command line ! Exiting.\n");
    exit(1);
  }
  fast_bencher_init;
  if (!strcmp(argv[1],"plus")) {
    return do_plus(argc-1,argv+1);
  } 
  if (!strcmp(argv[1],"mult")) {
    return do_mult(argc-1,argv+1);
  } 
  fprintf(stderr,"Unknown test: %s.\n",argv[1]);
  return 1;
}
