/* $Id: fast_bench_blas.c,v 1.2 2003/06/19 16:20:30 mquinson Exp $ */
/* a bench programm: runs all BLAS functions according to args */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include "../bench_utils.h"

/* stolen from cblas_f77.h, included directly to avoid to search for that */

#define FCHAR char *
#define FINT const int *

/*
 * Level 1 Fortran Prototypes
 */

/* Double Precision */

void drot_(FINT, double *, FINT, double *, FINT, const double *, const double *);
void drotg_(double *,double *,double *,double *);    
void drotm_( FINT, double *, FINT, double *, FINT, const double *);
void drotmg_(double *,double *,double *,const double *, double *);
void dswap_( FINT, double *, FINT, double *, FINT);
void dcopy_( FINT, const double *, FINT, double *, FINT);
void daxpy_( FINT, const double *, const double *, FINT, double *, FINT);
void dswap_( FINT, double *, FINT, double *, FINT);
void dsdot_sub_(FINT, const float *, FINT, const float *, FINT, double *);
void ddot_sub_( FINT, const double *, FINT, const double *, FINT, double *);
void dscal_( FINT, const double *, double *, FINT);
void dnrm2_sub_( FINT, const double *, FINT, double *);
void dasum_sub_( FINT, const double *, FINT, double *);
void idamax_sub_( FINT, const double * , FINT, FINT);

/*
 * Level 2 Fortran Prototypes
 */

/* Double Precision */

void dgemv_(FCHAR, FINT, FINT, const double *, const double *, FINT, const double *, FINT, const double *, double *, FINT);
void dgbmv_(FCHAR, FINT, FINT, FINT, FINT, const double *,  const double *, FINT, const double *, FINT, const double *, double *, FINT);
void dsymv_(FCHAR, FINT, const double *, const double *, FINT, const double *,  FINT, const double *, double *, FINT);
void dsbmv_(FCHAR, FINT, FINT, const double *, const double *, FINT, const double *, FINT, const double *, double *, FINT);
void dspmv_(FCHAR, FINT, const double *, const double *, const double *, FINT, const double *, double *, FINT);
void dtrmv_( FCHAR, FCHAR, FCHAR, FINT, const double *, FINT, double *, FINT);
void dtbmv_( FCHAR, FCHAR, FCHAR, FINT, FINT, const double *, FINT, double *, FINT);
void dtrsv_( FCHAR, FCHAR, FCHAR, FINT, const double *, FINT, double *, FINT);
void dtbsv_( FCHAR, FCHAR, FCHAR, FINT, FINT, const double *, FINT, double *, FINT);
void dtpmv_( FCHAR, FCHAR, FCHAR, FINT, const double *, double *, FINT);
void dtpsv_( FCHAR, FCHAR, FCHAR, FINT, const double *, double *, FINT);
void dger_( FINT, FINT, const double *, const double *, FINT, const double *, FINT, double *, FINT);
void dsyr_(FCHAR, FINT, const double *, const double *, FINT, double *, FINT);
void dspr_(FCHAR, FINT, const double *, const double *, FINT, double *); 
void dspr2_(FCHAR, FINT, const double *, const double *, FINT, const double *, FINT,  double *); 
void dsyr2_(FCHAR, FINT, const double *, const double *, FINT, const double *, FINT,  double *, FINT);

/*
 * Level 3 Fortran Prototypes
 */

/* Double Precision */

void dgemm_(FCHAR, FCHAR, FINT, FINT, FINT, const double *, const double *, FINT, const double *, FINT, const double *, double *, FINT);
void dsymm_(FCHAR, FCHAR, FINT, FINT, const double *, const double *, FINT, const double *, FINT, const double *, double *, FINT);
void dsyrk_(FCHAR, FCHAR, FINT, FINT, const double *, const double *, FINT, const double *, double *, FINT);
void dsyr2k_(FCHAR, FCHAR, FINT, FINT, const double *, const double *, FINT, const double *, FINT, const double *, double *, FINT);
void dtrmm_(FCHAR, FCHAR, FCHAR, FCHAR, FINT, FINT, const double *, const double *, FINT, double *, FINT);
void dtrsm_(FCHAR, FCHAR, FCHAR, FCHAR, FINT, FINT, const double *, const double *, FINT, double *, FINT);

/*****[ globals ]*************************************************************/
double *A,*B,*C,*X,*Y;
double alpha,beta; 
int M,N,K, sizeX,sizeY, LDA,LDB, ka,kb;
char transA, transB, trans, side,uplo,diag;
int INC=1; /* slicing of vectors */ 


/*****[ BLAS 1 ]**************************************************************/
int do_drotg(int argc,char **argv);
int do_drotmg(int argc,char **argv);
int do_drot(int argc,char **argv);       
int do_drotm(int argc,char **argv);
int do_dswap(int argc,char **argv);      
int do_dcopy(int argc,char **argv);      
int do_daxpy(int argc,char **argv);      
int do_ddot_sub(int argc,char **argv);
int do_dsdot_sub(int argc,char **argv);
int do_dscal(int argc,char **argv);
int do_dnrm2_sub(int argc,char **argv);
int do_dasum_sub(int argc,char **argv);
int do_dznrm2_sub(int argc,char **argv);
int do_dzasum_sub(int argc,char **argv);

/*****[ BLAS 2 ]**************************************************************/
int do_dsbmv(int argc,char **argv);
int do_dspmv(int argc,char **argv);
int do_dger(int argc,char **argv);
int do_dsyr(int argc,char **argv);
int do_dspr(int argc,char **argv);
int do_dsyr2(int argc,char **argv);
int do_dspr2(int argc,char **argv);

int do_dgemv(int argc,char **argv);
int do_dgbmv(int argc,char **argv);
int do_dtrmv(int argc,char **argv);
int do_dtbmv(int argc,char **argv);
int do_dtpmv(int argc,char **argv);
int do_dtrsv(int argc,char **argv);
int do_dtbsv(int argc,char **argv);
int do_dtpsv(int argc,char **argv);

/*----[ BLAS/dsbmv ]-----------------------------------------------------(2)-*/
int do_dsbmv(int argc,char **argv) {
  getarg(argc,argv,"Usage for dsbmv: uplo N K alpha beta",
	 "dsbmv(uplo=%c N=%d;K=%d; alpha=%lf;beta=%lf)",
	 &uplo,&M,&N,&alpha,&beta);
  LDA=K+1;  printf(" (LDA=%d)\n",LDA);
  A=dmallocset(LDA*N); X=dmallocset(N); Y=dmallocset(N);
  dsbmv_(&uplo,&N,&K,&alpha, A,&LDA, X,&INC, &beta,Y,&INC);
  return 0;
}
/*----[ BLAS/dspmv ]-----------------------------------------------------(2)-*/
int do_dspmv(int argc,char **argv) {
  getarg(argc,argv,"Usage for dspmv: uplo N alpha beta",
	 "dspmv(uplo=%c N=%d; alpha=%lf;beta=%lf)\n",
	 &uplo,&N,&alpha,&beta);
  A=dmallocset(N*(N+1)/2); B=dmallocset(N); C=dmallocset(N);
  dspmv_(&uplo,&N,&alpha, A, B,&INC, &beta,C,&INC);
  return 0;
}
/*----[ BLAS/dger ]------------------------------------------------------(2)-*/
int do_dger(int argc,char **argv) {
  getarg(argc,argv,"Usage for dger: M N alpha",
	 "dger(M=%d N=%d; alpha=%lf)\n",
	 &M,&N,&alpha);
  A=dmallocset(N*M); B=dmallocset(M); C=dmallocset(N);
  dger_(&M,&N,&alpha,B,&INC,C,&INC,A,&M);
  return 0;
}
/*----[ BLAS/dsyr ]------------------------------------------------------(2)-*/
int do_dsyr(int argc,char **argv) {
  getarg(argc,argv,"Usage for dsyr: uplo N alpha",
	 "dsyr(uplo=%c; N=%d; alpha=%lf)\n",
	 &uplo,&N,&alpha);
  A=dmallocset(N*N); B=dmallocset(N);
  dsyr_(&uplo,&N,&alpha,B,&INC,A,&N);
  return 0;
}
/*----[ BLAS/dspr ]------------------------------------------------------(2)-*/
int do_dspr(int argc,char **argv) {
  getarg(argc,argv,"Usage for dspr: uplo N alpha",
	 "dspr(uplo=%c; N=%d; alpha=%lf)\n",
	 &uplo,&N,&alpha);
  A=dmallocset((N*(N+1))/2); B=dmallocset(N);
  dspr_(&uplo,&N,&alpha,B,&INC,A);
  return 0;
}
/*----[ BLAS/dsyr2 ]-----------------------------------------------------(2)-*/
int do_dsyr2(int argc,char **argv) {
  getarg(argc,argv,"Usage for dsyr2: uplo N alpha",
	 "dsyr2(uplo=%c; N=%d; alpha=%lf)\n",
	 &uplo,&N,&alpha);
  A=dmallocset(N*N);  B=dmallocset(N);  C=dmallocset(N);
  dsyr2_(&uplo,&N,&alpha,B,&INC,C,&INC,A,&N);
  return 0;
}
/*----[ BLAS/dspr2 ]-----------------------------------------------------(2)-*/
int do_dspr2(int argc,char **argv) {
  getarg(argc,argv,"Usage for dspr2: uplo N alpha",
	 "dspr2(uplo=%c; N=%d; alpha=%lf)\n",
	 &uplo,&N,&alpha);
  A=dmallocset((N*(N+1))/2); B=dmallocset(N); C=dmallocset(N);
  dspr2_(&uplo,&N,&alpha,B,&INC,C,&INC,A);
  return 0;
}

/*----[ BLAS/dgemv ]-----------------------------------------------------(2)-*/
int do_dgemv(int argc,char **argv) {
  getarg(argc,argv,"Usage for dgemv: Trans M N alpha beta",
	 "dgemv(trans=%c M=%d;N=%d; alpha=%lf;beta=%lf)",
	 &transA,&M,&N,&alpha,&beta);
	
  sizeX=(trans == 'n' || trans == 'N' ? N : M);
  sizeY=(trans == 'n' || trans == 'N' ? M : N);
  printf(" (sizeX=%d,sizeY=%d)\n", sizeX,sizeY);

  A=dmallocset(M*N);  X=dmallocset(sizeX);  Y=dmallocset(sizeY);

  dgemv_(&trans,&M,&N,    &alpha,A,&M/*LDA*/,     X,&INC,     &beta,Y,&INC);
  return 0;
}

#if 0
/*----[ BLAS/dgbmv ]-----------------------------------------------------(2)-*/
int do_dgbmv(int argc,char **argv) {
  return 0;
}
/*----[ BLAS/dtrmv ]-----------------------------------------------------(2)-*/
int do_dtrmv(int argc,char **argv) {
  return 0;
}
/*----[ BLAS/dtbmv ]-----------------------------------------------------(2)-*/
int do_dtbmv(int argc,char **argv) {
  return 0;
}
/*----[ BLAS/dtpmv ]-----------------------------------------------------(2)-*/
int do_dtpmv(int argc,char **argv) {
  return 0;
}
/*----[ BLAS/dtrsv ]-----------------------------------------------------(2)-*/
int do_dtrsv(int argc,char **argv) {
  return 0;
}
/*----[ BLAS/dtbsv ]-----------------------------------------------------(2)-*/
int do_dtbsv(int argc,char **argv) {
  return 0;
}
/*----[ BLAS/dtpsv ]-----------------------------------------------------(2)-*/
int do_dtpsv(int argc,char **argv) {
  return 0;
}
#endif
/*****[ BLAS 3 ]**************************************************************/
/* prototypes */
int do_dgemm(int argc,char **argv);
int do_dsymm(int argc,char **argv);
int do_dsyrk(int argc,char **argv);
int do_dsyr2k(int argc,char **argv);
int do_dtrmm(int argc,char **argv);
int do_dtrsm(int argc,char **argv);

int do_dgemm_empty(int argc,char **argv);

/*----[ BLAS/dgemm ]-----------------------------------------------------(3)-*/
int do_dgemm(int argc,char **argv) {
  getarg(argc,argv,"Usage for dgemm: TransA TransB M N K alpha beta",
	 "dgemm(transA=%c transB=%c M=%d;N=%d;K=%d alpha=%lf;beta=%lf)",
	 &transA,&transB,&M,&N,&K,&alpha,&beta);

  LDA=(transA == 'n' || transA == 'N' ? M : K);
  ka =(transA == 'n' || transA == 'N' ? K : M);

  LDB=(transB == 'n' || transB == 'N' ? K : N);
  kb =(transB == 'n' || transB == 'N' ? N : K);
  printf("(LDA=%d,LDB=%d)\n",LDA,LDB);

  A=dmallocset(LDA*ka);   B=dmallocset(LDB*kb);   C=dmallocset(M*N);

  dgemm_(&transA,&transB,&M,&N,&K,  &alpha,A,&LDA,  B,&LDB,   &beta,C,&M);
  return 0;
}

/*----[ BLAS/dsymm ]-----------------------------------------------------(3)-*/
int do_dsymm(int argc,char **argv) {
  getarg(argc,argv,"Usage for dsymm: side uplo M N alpha beta",
	 "dsymm(side=%c uplo=%c M=%d;N=%d alpha=%lf;beta=%lf)",
	 &side,&uplo,&M,&N,&alpha,&beta);

  LDA=(side == 'l' || side == 'L' ? M : N);
  ka =(side == 'l' || side == 'L' ? M : N);
  printf("  (LDA=%d)\n",LDA);

  A=dmallocset(LDA*ka); B=dmallocset(M*N);  C=dmallocset(M*N);

  dsymm_(&side,&uplo,&M,&N, &alpha, A,&LDA,  B,&M/*LDB*/, &beta,  C,&M/*LDC*/);
  return 0;
}

/*----[ BLAS/dsyrk ]-----------------------------------------------------(3)-*/
int do_dsyrk(int argc,char **argv) {
  getarg(argc,argv,"Usage for dsyrk: uplo trans N K alpha beta",
	 "dsyrk(uplo=%c trans=%c N=%d;K=%d alpha=%lf;beta=%lf)",
	 &uplo,&trans,&N,&K,&alpha,&beta);

  LDA=(trans == 'n' || trans == 'N' ? N : K);
  ka =(trans == 'n' || trans == 'N' ? K : N);
  printf("  (LDA=%d)\n",LDA);

  A=dmallocset(LDA*ka);  C=dmallocset(N*N);

  dsyrk_(&uplo,&trans,&N,&K,&alpha, A,&LDA,&beta, C,&N/*LDC*/);
  return 0;
}

/*----[ BLAS/dsyr2k ]----------------------------------------------------(3)-*/
int do_dsyr2k(int argc,char **argv) {
  getarg(argc,argv,"Usage for dsyr2k: uplo trans N K alpha beta",
	 "dsyr2k(uplo=%c trans=%c N=%d;K=%d alpha=%lf;beta=%lf)",
	 &uplo,&trans,&N,&K,&alpha,&beta);

  LDA=(trans == 'n' || trans == 'N' ? N : K);
  ka =(trans == 'n' || trans == 'N' ? K : N);
  printf("  (LDA=%d)\n",LDA);

  A=dmallocset(LDA*ka);  B=dmallocset(LDA*ka);  C=dmallocset(N*N);

  dsyr2k_(&uplo,&trans,&N,&K,&alpha, A,&LDA, B,&LDA, &beta, C,&N/*LDC*/);
  return 0;
}
/*----[ BLAS/dtrmm ]-----------------------------------------------------(3)-*/
int do_dtrmm(int argc,char **argv) {
  getarg(argc,argv,"Usage for dtrmm: side uplo trans diag M N",
	 "dtrmm(side=%c uplo=%c trans=%c diag=%c M=%d;N=%d)",
	 &side,&uplo,&trans,&diag,&M,&N);

  LDA=(side == 'L' || side == 'l' ? M : N);
  ka =(side == 'L' || side == 'l' ? M : N);
  printf("  (LDA=%d)\n",LDA);

  A=dmallocset(LDA*ka);  B=dmallocset(M*N);

  dtrmm_(&side,&uplo,&trans,&diag,  &M,&N, &alpha,   A, &LDA, B, &M);
  return 0;
}
/*----[ BLAS/dtrsm ]-----------------------------------------------------(3)-*/
int do_dtrsm(int argc,char **argv) {
  getarg(argc,argv,"Usage for dtrsm: SIDE UPLO TRANSA DIAG M N",
	 "dtrsm(side=%c uplo=%c trans=%c diag=%c M=%d;N=%d)",
	 &side,&uplo,&trans,&diag,&M,&N);

  LDA=(side == 'L' || side == 'l' ? M : N);
   ka=(side == 'L' || side == 'l' ? M : N);
  printf("(LDA=%d)\n",LDA);

  A=dmallocset(LDA*ka);  B=dmallocset(M*N);

  dtrsm_(&side,&uplo,&trans,&diag,  &M,&N, &alpha,   A, &LDA, B, &M);
  return 0;
}

/*----[ BLAS/dgemm_empty ]-----------------------------------------------(3)-*/
int do_dgemm_empty(int argc,char **argv) {
  getarg(argc,argv,"Usage for dgemm: TransA TransB M N K alpha beta",
	 "dgemm(transA=%c transB=%c M=%d;N=%d;K=%d alpha=%lf;beta=%lf)",
	 &transA,&transB,&M,&N,&K,&alpha,&beta);

  LDA=(transA == 'n' || transA == 'N' ? M : K);
  ka =(transA == 'n' || transA == 'N' ? K : M);

  LDB=(transB == 'n' || transB == 'N' ? K : N);
  kb =(transB == 'n' || transB == 'N' ? N : K);
  printf("(LDA=%d,LDB=%d)\n",LDA,LDB);

  A=dmallocset(LDA*ka);  B=dmallocset(LDB*kb);  C=dmallocset(M*N);
  return 0;
}

/*****[ main ]****************************************************************/

int main(int argc,char **argv)
{
  if (argc==1) {
    fprintf(stderr,"Missing args on command line ! Exiting.\n");
    exit(1);
  }
  fast_bencher_init;
  /* BLAS 1 */
  
  /* BLAS 2 */
  if (!strcmp(argv[1],"dsbmv"))       return do_dsbmv(argc-1,argv+1);
  if (!strcmp(argv[1],"dspmv"))       return do_dspmv(argc-1,argv+1);
  if (!strcmp(argv[1],"dger"))        return do_dger(argc-1,argv+1);
  if (!strcmp(argv[1],"dsyr"))        return do_dsyr(argc-1,argv+1);
  if (!strcmp(argv[1],"dspr"))        return do_dspr(argc-1,argv+1);
  if (!strcmp(argv[1],"dsyr2"))       return do_dsyr(argc-1,argv+1);
  if (!strcmp(argv[1],"dspr2"))       return do_dspr2(argc-1,argv+1);

  if (!strcmp(argv[1],"dgemv"))       return do_dgemv(argc-1,argv+1);
  /*
  if (!strcmp(argv[1],"dgbmv"))       return do_dgbmv(argc-1,argv+1); 
  if (!strcmp(argv[1],"dtrmv"))       return do_dtrmv(argc-1,argv+1);
  if (!strcmp(argv[1],"dtbmv"))       return do_dtbmv(argc-1,argv+1);
  if (!strcmp(argv[1],"dtpmv"))       return do_dtpmv(argc-1,argv+1);
  if (!strcmp(argv[1],"dtrsv"))       return do_dtrsv(argc-1,argv+1);
  if (!strcmp(argv[1],"dtbsv"))       return do_dtbsv(argc-1,argv+1);
  if (!strcmp(argv[1],"dtpsv"))       return do_dtpsv(argc-1,argv+1);
  */

  /* BLAS 3 */
  if (!strcmp(argv[1],"dgemm"))       return do_dgemm(argc-1,argv+1);
  if (!strcmp(argv[1],"dsymm"))       return do_dsymm(argc-1,argv+1);
  if (!strcmp(argv[1],"dsyrk"))       return do_dsyrk(argc-1,argv+1);
  if (!strcmp(argv[1],"dsyr2k"))      return do_dsyr2k(argc-1,argv+1);
  if (!strcmp(argv[1],"dtrmm"))       return do_dtrmm(argc-1,argv+1);
  if (!strcmp(argv[1],"dtrsm"))       return do_dtrsm(argc-1,argv+1);

  if (!strcmp(argv[1],"dgemm_empty")) return do_dgemm_empty(argc-1,argv+1);

  fprintf(stderr,"Unknown test: %s.\n",argv[1]);
  return 1;
}
