/* a stupid bench programm: runs several FFT functions from the GSL according to args */
/* FIXME: Note, each FFT is runned 1000 times to amortize the initialisation time */
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "../bench_utils.h"

#include <gsl/gsl_errno.h>
#include <gsl/gsl_fft_complex.h>

/* prototypes */
int do_forward(int N);
int do_backward(int N);
int do_inverse(int N);

#define MAX(a,b) (a > b ? a : b)
#define XP_COUNT 10000
#define RESET    10
gsl_fft_complex_wavetable * wavetable;
gsl_fft_complex_workspace * workspace;
double *data;
/*----[ forward ]------------------------------------------------------------*/
int do_forward(int N) {
  int i;

  printf("fft_forward N=%d\n",N);
  data=(double *)malloc(sizeof(double)*N*2);

  wavetable = gsl_fft_complex_wavetable_alloc (N);
  workspace = gsl_fft_complex_workspace_alloc (N);

  for (i=0; i<XP_COUNT; i++) {
    if (i%RESET == 0) 
      memset(data,(double) rand()/(rand()+1),sizeof(double)*N*2);
    gsl_fft_complex_forward (data, 1, N,
			     wavetable, workspace);
    //    printf("%d ",i);fflush(stdout);
  }
  return 0;
}



   
/*----[ backward ]-----------------------------------------------------------*/
int do_backward(int N) {
  int i;
   
  printf("fft_forward N=%d\n",N);
  data=(double *)malloc(sizeof(double)*N*2);

  wavetable = gsl_fft_complex_wavetable_alloc (N);
  workspace = gsl_fft_complex_workspace_alloc (N);

  for (i=0; i<XP_COUNT; i++) {
    if (i%RESET == 0) 
      memset(data,(double) rand()/(rand()+1),sizeof(double)*N*2);
    gsl_fft_complex_forward (data, 1, N,
			     wavetable, workspace);
  }
  return 0;
}
/*----[ inverse ]------------------------------------------------------------*/
int do_inverse(int N) {
  int i;

  printf("fft_forward N=%d\n",N);
  data=(double *)malloc(sizeof(double)*N*2);

  wavetable = gsl_fft_complex_wavetable_alloc (N);
  workspace = gsl_fft_complex_workspace_alloc (N);

  for (i=0; i<XP_COUNT; i++) {
    if (i%RESET == 0) 
      memset(data,(double) rand()/(rand()+1),sizeof(double)*N*2);
    gsl_fft_complex_forward (data, 1, N,
			     wavetable, workspace);
  }
  return 0;
}

void handler (const char * reason,
	      const char * file,
	      int line,
	      int gsl_errno);
void handler (const char * reason,
	      const char * file,
	      int line,
	      int gsl_errno) {
  fprintf(stderr,"Error!\n");
  exit(1);
}

/*----[ main ]--------------------------------------------------------------*/
int main(int argc,char **argv)
{
  int i;
  int N=1;
  
  if (argc!=6) {
    fprintf(stderr,"argc=%d\nUsage: (forward|backward|inverse) #2 #3 #4 #5 #6 #7\n",argc);
    exit(1);
  }
  fast_bencher_init;
  gsl_set_error_handler (&handler);
  srand(time(NULL));
   
//  fprintf(stderr,"                      ");
  for (i=2; i<6;i++) {
//     fprintf(stderr,"N(=%d)*= %d**",N,i);
//     fprintf(stderr,"%d ",(int)atof(argv[i]));
     N*=(int)pow((double)i, atof(argv[i]));
     if (N>10000) {
       fprintf(stderr,"%d Too big\n",N);
       exit(2);
     }
  }
//  fprintf(stderr,"Ok\n");
  if (!N) exit(1);
  if (!strcmp(argv[1],"forward")) {
    return do_forward(N);
  } 
  if (!strcmp(argv[1],"backward")) {
    return do_backward(N);
  } 
  if (!strcmp(argv[1],"inverse")) {
    return do_inverse(N);
  } 
  fprintf(stderr,"Unknown test: %s.\n",argv[1]);
  return 1;
}
