     /*---------------------------------------------------------------*\
     | File:    bench.c                                                |
     | Project: FAST                                                   |
     | Author:  Martin.QUINSON@ens-lyon.fr                             |
     | Date:                                                           |
     \*---------------------------------------------------------------*/

/*$Id: autobench.c,v 1.3 2005/03/05 17:51:01 mquinson Exp $*/
#include <sys/time.h>

#include "bench_all.h"
#include "store2ldif.h"
#include "input_text.h"

#include "../libfast/Utils/diagnostic.h"

const char usage[]="Usage: fast_bench file_of_todos\n";

int main(int argc, char **argv) 
{ 
  fast_benchs_to_store_t *to_store;
  fast_bench_workspace_t *workspace;

  //  DirectDiagnostics(DIAGDEBUG, stdout);
  DirectDiagnostics(DIAGINFO, stdout);
  DirectDiagnostics(DIAGLOG, stdout);
  DirectDiagnostics(DIAGWARN, stderr);
  DirectDiagnostics(DIAGERROR, stderr);
  DirectDiagnostics(DIAGFATAL, stderr);

  if (argc!=2) {
    fprintf(stderr,usage);
    return 1;
  }

  if (!fast_bench_workspace_new(&workspace) ||
      !fast_bench_from_text(argv[1],workspace) ||
      !fast_bench_all(workspace) ||
      !fast_bench_workspace_to_store(workspace,&to_store) ||
      !store2ldif(to_store,NULL) ) { 
    printf("Well, there was a problem during the benching\n");
    return 1;
  }

  return 0;
}     


