/* $Id: autobench.h,v 1.1 2003/05/26 10:51:53 mquinson Exp $ */

/* autobench - the automatic bencher of FAST */

#ifndef _FAST_H
#define _FAST_H

/* The separator used between parts in strings */
#define FAST_SEP '!'

#define OPTION_NAME_LEN (31 + 1)
struct fast_option_info_ {
  char name[OPTION_NAME_LEN];
  unsigned int minOccurrences;
  unsigned int maxOccurrences;
  char format;
};
typedef struct fast_option_info_ fast_option_info_t;

/*====[ OPTIONS ]============================================================*/
/*----[ Bench options ]------------------------------------------------------*/

#define FAST_MEM_NO     0 /* do not try to get infos about the memory need   */
#define FAST_MEM_STD    1 /* normal check of the memory use                  */
#define FAST_MEM_HIGH   3 /* stops the benched program after each step to    */
			  /* check its memory use. Very slow.                */

#define FAST_TIME_NO    0 /* do not measure the needed time                  */
#define FAST_TIME       4 /* use the system + user time as measurement       */

/*----[ Buffering options ]--------------------------------------------------*/

#define FAST_BUF_IN    16 /* use the buffered values if they exist           */
#define FAST_BUF_DO    32 /* do the test even if the value is buffered       */
#define FAST_BUF_OUT   64 /* save the result in the buffer                   */
#define FAST_BUF_CREATE 128 /* create a slot in the buffer if needed         */

/*----[ Fitting options ]----------------------------------------------------*/

#define FAST_FIT_NONE   0 /* polynomial order = 1                            */
#define FAST_FIT_LOW  256 /*                  = 2                            */
#define FAST_FIT_MED  512 /*                  = number of parameters         */
#define FAST_FIT_HIGH 768 /*                  = 2 * number of parameters     */

#define FAST_DEFAULT_OPTIONS   FAST_MEM_STD | FAST_TIME \
                             | FAST_BUF_IN |FAST_BUF_OUT|FAST_BUF_CREATE\
                             | FAST_FIT_HIGH


#endif
