/* $Id: bench_all.h,v 1.4 2003/06/04 12:02:26 pmachard Exp $ */

/* bench_all - run all the needed experiments */

#ifndef _BENCH_ALL_H
#define _BENCH_ALL_H


#include "autobench.h"
#include "buffer.h"

/* internal type: workspace for all tests */
typedef struct fast_bench_workspace_ fast_bench_workspace_t;

/* struct describing the result of the bench and data fiting (to feed output
   plugin) */
struct fast_benchs_to_store_ {
  char *category; /* name of the benched function (example dgemm) */
  char *id; /* the string args (example n%t) */
  char *time_interp; /* the coefs of the polynomiale function (for time) */
  char *space_interp; /* idem for space */

  struct fast_benchs_to_store_ *next;
};
typedef struct fast_benchs_to_store_ fast_benchs_to_store_t;

/**
 * fast_bench_workspace_new:
 *
 * Create the struct
 */

int fast_bench_workspace_new(fast_bench_workspace_t **ws);

/**
 * fast_bench_workspace_add:
 *
 * Add things to do in the workspace
 */

int fast_bench_workspace_add(fast_bench_workspace_t *ws,
			     char *category,
			     char *binary,
			     char *args,
			     int options);

/**
 * fast_bench_all:
 *
 * The magic function doing all the kernel of fast/bench :
 *   - parse the args to see which tests are needed
 *   - realize them
 *   - interpolate the result
 *   - build an answer to feed the output plugin
 * (the todo in input are in a linked list, and the answer also)
 */

int fast_bench_all(fast_bench_workspace_t *ws);

/**
 * fast_bench_workspace_to_store:
 *
 * build a linked list of things to store from the workspace
 */

int 
fast_bench_workspace_to_store(fast_bench_workspace_t *workspace,
			      fast_benchs_to_store_t **to_store);

#endif /* _BENCH_ALL_H */
