/* $Id: buffer.h,v 1.4 2003/06/14 09:16:28 mquinson Exp $ */

/* buffer - generic interface to the different kind of buffering mecanism */

#ifndef _BUFFER_H
#define _BUFFER_H
#include "autobench.h"

typedef struct fast_buff_s fast_buff_t ;

/**
 * fast_buff_open:
 * @whereto: where to store the newly created DB handler.
 *
 * Create a new buffer. It will be of the first available type.
 */
void fast_buff_open(fast_buff_t **whereto,
		    const char *category,const char *file,const char *path);

/**
 * fast_buff_close:
 *
 * Close the given database.
 */
void fast_buff_close(fast_buff_t *db);

/**
 * fast_buff_retrieve:
 *
 * Get from the #db the values #db_time and #db_space for these 
 * #string_id and numerical arguments.
 */
void fast_buff_retrieve(fast_buff_t *db,
			char *string_id, int nb_params, double *params,
			double *db_time,double *db_space);
/**
 * fast_buff_store:
 *
 * Store from the #db the values #db_time and #db_space for these 
 * #string_id and numerical arguments.
 */
void fast_buff_store(fast_buff_t *this,
		     char *string_id, int nb_params, double *params,
		     double db_time,double space);


#endif /* _BUFFER_H */
