/* $Id: testsset.h,v 1.2 2003/06/03 12:10:59 mquinson Exp $ */

/* testsset.h - functions to handle a set of tests grouped by string id      */

/* Copyright (C) 2001,2002,2003 the OURAGAN project.                         */
/* Code available under BSD-like licence (see COPYRIGHT file).               */
/* Author(s): Martin Quinson                                                 */
#ifndef TESTSSET_H_
#define TESTSSET_H_
/*----[ fast_testsset_bench_all_t ]------------------------------------------*/
/* Contains all the tests about one string id                                */
/*---------------------------------------------------------------------------*/
struct fast_bench_testsset_ {
  char *id; /* the string args identifiing this set of tests */

  int nb_params; /* number of numerical parameters */

  double *t_params; /* the list of all values of numerical tests 
		       _* for time values *_
		       params[A_i,XP_k]=K*nb_params + i */
  double *t_val; /* timing benched  */
  double *t_buf; /* timing buffered */
  int t_size; /* timing test there */

  double *s_params; /* the list of all values of numerical tests 
		       _* for space values *_
		       params[A_i,XP_k]=K*nb_params + i */
  double *s_val; /* space benched */
  double *s_buf; /* space buffered */
  int s_size; /* spacing test there */
};
typedef struct fast_bench_testsset_ fast_bench_testsset_t;

/*****[ Basic functions ]*****************************************************/
void 
fast_bench_testsset_free(fast_bench_testsset_t *testsset);

fast_bench_testsset_t * 
fast_bench_testsset_new(char *id /* id to use */, 
			 int size /* how many bench planed */,
			 /* how many numerical params in benchs */
			 int nb_params);
void fast_bench_testsset_dump(fast_bench_testsset_t *testsset);

/*----[ f_b_w_clean ]--------------------------------------------------------*/
/* Removes empty values from the table before interpolation                  */
/* FIXME: not implemented */
/*---------------------------------------------------------------------------*/
int 
fast_bench_testsset_clean(fast_bench_testsset_t *testsset);

#endif /* TESTSSET_H_ */
