/* $Id: fast_booking.h,v 1.2 2003/07/09 14:12:49 mquinson Exp $ */

/* fast_booking - how scheduler inform FAST of its decision for reactivity*/
/*                See HOWORKS-booking                                     */

/* Copyright (C) 2001,2002,2003 the OURAGAN project.                      */
/* Code GPL'ed (see www.gnu.org).                                         */

/* Author(s): Martin Quinson                                              */

#ifndef _FAST_BOOKING_INTERNALS_H_
#define _FAST_BOOKING_INTERNALS_H_

/* ***********************************************************************
 * The datatypes involved in booking
 * ***********************************************************************/

typedef enum {
  fast_cbook_created=0,
  fast_cbook_applied,
  fast_cbook_running,
  fast_cbook_ended
} fast_cbook_status_t;

/* fast_cbook_t: A booking (public) */
struct fast_cbook_s {
  char *host;
  int space,time;  /* how much space (Mo) and time(s) is booked */
  double cpu_load; /* which fraction of CPU is booked for that time 
		      (>1 if it takes several CPUs) */

  fast_cbook_status_t status; /* current status of the booking */
  double ctime,atime,etime; /* when it was created, applied or ended */
};

/* fast_cbook_coll_t: All booking about a perticular host */
typedef struct {
  int size;
  int used;
  fast_cbook_t **book;
} fast_cbook_coll_t;


#endif /* _FAST_BOOKING_INTERNALS_H_ */
