/* $Id: fast_need_plugins.h,v 1.2 2003/06/04 11:28:18 mquinson Exp $ */

/* fast_need_plugins - the retrieval functions in the different storage      */

/* Copyright (C) 2001 the OURAGAN project. Code GPL'ed (see www.gnu.org).    */
/* Author(s): Martin Quinson                                                 */

#ifndef _FAST_NEED_PLUGINS_H_
#define _FAST_NEED_PLUGINS_H_

#include "fast_internals.h"

/* A plugin type */
typedef struct {
  const char *name;
  int (*init)(void);
  int (*getestimator)(const char*,const char*,const char*,fast_estimator_t***);
} fast_need_plugin_t;

/*---[ Prototypes of all plugins ]-------------------------------------------*/
#ifdef HAVE_LDAP
int fast_ldap_init(void);
int fast_ldap_getestimator(const char *host,const char *routine_name,
			   const char *stringargs,
			   /* OUT */ fast_estimator_t ***retrieved);
#endif 

/****[ The table of the plugins ]****/
extern const int fast_need_plugins_count;
extern const fast_need_plugin_t fast_need_plugins[];

#endif /* _FAST_NEED_PLUGINS_H_ */
