#include "fast_internals.h"

int main() {
  double value;
  data_argstack_t *argstack;
  
  /* Redirect the outputs */
  //  DirectDiagnostics(DIAGDEBUG, stdout);
  //DirectDiagnostics(DIAGINFO, stdout);
  DirectDiagnostics(DIAGLOG, stdout);
  DirectDiagnostics(DIAGWARN, stdout);
  DirectDiagnostics(DIAGERROR, stdout);
  DirectDiagnostics(DIAGFATAL, stdout);

  if (system("./minildap start") ||
      system("./minildap test")) {
    ERROR("Can't start minildap.\n");
    return 1;
  }

  if (!fast_init("ldap_server","localhost",9059,
		 "ldap_binddn","dc=LIP,dc=ens-lyon,dc=fr",
		 "ldap_debug",96/*4095*/,
		 "nws_use",0,
		 NULL)) {
    printf("Unable to contact the LDAP server.\n");
    return 1;
  }
  
  printf("Check for size=256\n");
  if (!data_argstack_create(&argstack,"BLAS/dgemm",7,
			    data_arg_char_new('n'),
			    data_arg_char_new('n'),
			    data_arg_int_new(256),
			    data_arg_int_new(256),
			    data_arg_int_new(256),
			    data_arg_char_new('1'),
			    data_arg_char_new('0')))
    return 2;
  data_argstack_dump(argstack);
  if (!fast_need(FAST_NEED_TIME,"blaise",argstack,&value))
    return 3;
  printf ("Need %f s to do the computation\n",value);

  data_argstack_free(argstack);

  printf("Test for size=1024\n");
  if (!data_argstack_create(&argstack,"BLAS/dgemm",7,
			    data_arg_char_new('t'),
			    data_arg_char_new('t'),
			    data_arg_int_new(1024),
			    data_arg_int_new(1024),
			    data_arg_int_new(1024),
			    data_arg_char_new('1'),
			    data_arg_char_new('0')))
    return 2;

  if (!fast_need(FAST_NEED_TIME,"blaise",argstack,&value))
    return 3;
  printf ("Need %f s to do the computation\n",value);

  if (system("./minildap stop")) {
    ERROR("Can't stop minildap\n");
    return 1;
  }

  return 0;
}

