#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include <nws_api.h>

#include "../../Utils/diagnostic.h"

//#define LOCALHOST "localhost.localdomain"
#define NS        "localhost.localdomain"
#define NSPORT   9990

int main () {
  NWSAPI_HostSpec nsSpec;
  int i;


  DirectDiagnostics(DIAGINFO, stdout);
  DirectDiagnostics(DIAGLOG, stdout);
  DirectDiagnostics(DIAGWARN, stderr);
  DirectDiagnostics(DIAGERROR, stderr);
  DirectDiagnostics(DIAGFATAL, stderr);


  system("nws_localadmin -c nws.conf stop");
  system("nws_localadmin -c nws.conf start");

  nsSpec = *NWSAPI_MakeHostSpec (NS,NSPORT); 
  if (!NWSAPI_UseNameServer(&nsSpec)) {
    fprintf(stderr,"NWS_init: Unable to contact the NWS name server %s:%d\n",
	    nsSpec.machineName, nsSpec.machinePort);
    exit(1);
  }
  fprintf(stderr,"NWS_init: contact %s:%d as NWS nameserver\n",
	  nsSpec.machineName, nsSpec.machinePort);

  fprintf(stderr,"\nHere are the series found by nws_search:\n");
  system("nws_search -N localhost:9990 series");

  if (!NWSAPI_AutoFetchBegin("localhost.localdomain:9995.availableCpu.0") ||
	!NWSAPI_AutoFetchBegin("localhost.localdomain:9995.currentCpu.0")) {
    fprintf(stderr,"Cannot start the autofetches\n");
    exit(1);
  }
  fprintf(stderr,"Started to autofetchs. Waiting for incomming values\n");
  
  for (i=0; i<60; i++) {
    char serieName[1024];
    NWSAPI_Measurement measurementCollection;

    while (NWSAPI_AutoFetchCheck(serieName,1024,&measurementCollection,0)) {
      fprintf(stderr,"Got an autofetched value for %s (%.0f: %f)\n",
	      serieName,
	      measurementCollection.timeStamp,
	      measurementCollection.measurement);
    }

    sleep(1);
  }

  fprintf(stderr,"Stoping the system\n");
  system("nws_localadmin -c nws.conf stop");

  return 1;
}
