/* $Id: argstack.c,v 1.3 2003/06/19 16:24:08 mquinson Exp $ */

/* Test program for argstacks                                             */

/* Copyright (C) 2001,2002,2003 the OURAGAN project.                      */
/* Code available under BSD-like licence (see COPYRIGHT file).            */
/* Author(s): Martin Quinson                                              */

#include "fast_internals.h"

#define TEST_ARG_INIT(name,creation,init) \
  do {                               \
    data_arg_t *arg=creation;        \
    init                             \
    data_arg_dump(arg,name,"");      \
    data_arg_free(&arg);             \
  } while (0) 
    
#define TEST_ARG(name,creation) \
  do {                               \
    data_arg_t *arg=creation;        \
    data_arg_dump(arg,name,"");      \
    data_arg_free(&arg);             \
  } while (0) 


int main (int argc, char *argv[]) {

  //DirectDiagnostics(DIAGDEBUG, stdout);
  DirectDiagnostics(DIAGINFO, stdout);
  DirectDiagnostics(DIAGLOG, stdout);
  DirectDiagnostics(DIAGWARN, stderr);
  DirectDiagnostics(DIAGERROR, stderr);
  DirectDiagnostics(DIAGFATAL, stderr);

  TEST_ARG( "char e",      data_arg_char_new('e'));
  TEST_ARG( "int 123",     data_arg_int_new(123));
  TEST_ARG( "double 12.3", data_arg_double_new(12.3));

  TEST_ARG( "int vect",    data_arg_vect_new(data_int,123));
  TEST_ARG_INIT( "resized int vect",    data_arg_vect_new(data_int,123), 
	    data_arg_pset_int(arg,"size",1024); );
  TEST_ARG( "int mat",     data_arg_mat_new(data_int,123,123));

  TEST_ARG( "string(AZE)", data_arg_string_new("AZE"));
  TEST_ARG_INIT( "changed string(AZE)", data_arg_string_new("AZE"), 
	    data_arg_pset_string(arg,"value","QWERTY");
	    data_arg_pset_int(arg,"size",strlen("QWERTY"));
	   );

  TEST_ARG( "file",        data_arg_file_new("AZE"));


  
  return 0;
}
