/* $Id: estimator.c,v 1.2 2003/06/03 14:04:03 mquinson Exp $ */

/* Test code for estimators.                                              */

/* Copyright (C) 2001,2002,2003 the OURAGAN project.                      */
/* Code available under BSD-like licence (see COPYRIGHT file).            */
/* Author(s): Martin Quinson                                              */

#include "fast_internals.h"

void test(int NBPARAMS,int SIZEOFDATA);
#define MAT_VAL(mat,sizej,i,j) (mat[(sizej)*(i)+(j)])

void test(int NBPARAMS,int SIZEOFDATA) {
  int i,j;
  double val;

  double *knots=(double *)malloc(sizeof(double)*NBPARAMS*SIZEOFDATA);
  double *y    =(double *)malloc(sizeof(double)*SIZEOFDATA);
  fast_estimator_t *estimator,*estim2;
  char *estim_str;
  srand (time(NULL));
  
  if (!knots || !y) {
    fprintf(stderr,"Malloc error");
    exit(1);
  }
  for (i=0; i<SIZEOFDATA; i++) {
    val = 1;
    for (j=0; j<NBPARAMS; j++) {      
      MAT_VAL(knots,NBPARAMS,i,j)=rand()%100+1;
      val += pow(MAT_VAL(knots,NBPARAMS,i,j),2);
      val += 37*pow(MAT_VAL(knots,NBPARAMS,i,j),3) ;
      val -= MAT_VAL(knots,NBPARAMS,i,j);
      if (j>0)
	val += MAT_VAL(knots,NBPARAMS,i,j) * MAT_VAL(knots,NBPARAMS,i,j-1);
    }
    val -= 10000;
    y[i]=val;
  }

  estimator=fast_estimator_alloc_array(NBPARAMS,SIZEOFDATA,knots, y,
				       /* order */NBPARAMS*2);
  fast_estimator_dump(stdout,estimator);
  fast_estimator_test_array(estimator,NBPARAMS,SIZEOFDATA,knots, y);

  estim_str = fast_estimator_to_string(estimator);
  estim2= fast_estimator_alloc_from_string(estim_str);
  free(estim_str);
  estim_str=fast_estimator_to_string(estim2);

  free(estim_str);
  fast_estimator_free(estimator);
  fast_estimator_free(estim2);
}


int main () {
  int NBPARAMS,SIZEOFDATA;
  for (NBPARAMS=3 ; NBPARAMS<4 ; NBPARAMS++) 
    for (SIZEOFDATA=10000 ; SIZEOFDATA<10001 ; SIZEOFDATA *=10) {
      printf("Test pour %d params, et %d XP a l'ordre %d\n",
	     NBPARAMS,SIZEOFDATA,NBPARAMS);
      test(NBPARAMS,SIZEOFDATA);
    }
  return 0;
}

