
#include "fast_diagnostic.h"
#include "fast_xml.h" /* functions to read FAST data from xml file */

int main(int argc, char **argv) {
  fast_xml_problemSet_t *cur;

  DirectDiagnostics(DIAGDEBUG, stdout);
  DirectDiagnostics(DIAGINFO, stdout);
  DirectDiagnostics(DIAGLOG, stdout);
  DirectDiagnostics(DIAGWARN, stderr);
  DirectDiagnostics(DIAGERROR, stderr);
  DirectDiagnostics(DIAGFATAL, stderr);

  if (argc != 2) {
    fprintf(stderr,"Usage: %s problemset\n",argv[0]);
    exit (1);
  }
  if (!fast_xml_parseFile(argv[1],&cur)) {
    fprintf( stderr, "Error parsing file '%s'\n", argv[1]);
    exit(2);
  }
  fast_xml_print(cur);
    
  return(0);
}
