/* $Id: fast.h,v 1.3 2003/06/19 16:21:57 mquinson Exp $ */

/* fast.h - client API to FAST.                                           */

/* Copyright (C) 2001,2002,2003 the OURAGAN project.                      */
/* Code available under BSD-like licence (see COPYRIGHT file).            */
/* Author(s): Martin Quinson                                              */

#ifndef _FAST_H
#define _FAST_H

#include <unistd.h>
#include <stdarg.h> /* va_arg */

#ifdef __cplusplus
# define FAST_BEGIN_DECL extern "C" {
# define FAST_END_DECL }
#else
# define FAST_BEGIN_DECL 
# define FAST_END_DECL 
#endif


#include <fast/data_arg.h>
#include <fast/data_argstack.h>
#include <fast/high_level.h>
#include <fast/need.h>
#include <fast/avail.h>
#include <fast/booking.h>

FAST_BEGIN_DECL


/*===========================================================================*/
/*====[ ip_t ]===============================================================*/
/* (it may defined in several parts of the code)                             */
#ifndef ip_t
#define ip_t unsigned int
#endif
ip_t ip_str2ip_t(const char *ip);
/* result is volatil, and will be overwritten in the next call */
char *ip_t2ip_str(ip_t ip);


FAST_END_DECL
#endif /* _FAST_H */
