/* $Id: need.h,v 1.1 2003/06/03 14:04:04 mquinson Exp $ */

/* need.h - Low level interface to routine's need forecasting.            */

/* Copyright (C) 2001,2002,2003 the OURAGAN project.                      */
/* Code available under BSD-like licence (see COPYRIGHT file).            */
/* Author(s): Martin Quinson                                              */

#ifndef _FAST_NEED_H_
#define _FAST_NEED_H_

#ifdef __cplusplus
extern "C" {
#endif

/*----[ needed resources enum ]----------------------------------------------*/
#define FAST_NEED_TYPE_COUNT    2

#define FAST_NEED_TIME   0
#define FAST_NEED_SPACE  1

/*----[ fast_need ]----------------------------------------------------------*/
/* Search the needs of an implementations instance.                          */
/*---------------------------------------------------------------------------*/
int fast_need(int need, const char *host, data_argstack_t *argstack,
	      /*OUT*/double *value);

/*----[ Simple wrappers ]----------------------------------------------------*/
int fast_need_time(const char *host, data_argstack_t *argstack,double *value);
int fast_need_space(const char *host, data_argstack_t *argstack,double *value);

#ifdef __cplusplus
}
#endif
#endif /* _FAST_NEED_H_ */
